namespace experiment
{
    using System;
    using System.Collections;
    using System.ComponentModel;
    using System.Data;
    using System.Drawing;
    using System.Web;
    using System.Web.SessionState;
    using System.Web.UI;
    using System.Web.UI.WebControls;
    using System.Web.UI.HtmlControls;
	using System.Data.SqlClient;

    /// <summary>
    ///    Summary description for Registration.
    /// </summary>
    public class Registration : System.Web.UI.Page
    {
		protected System.Web.UI.WebControls.TextBox FName;
		protected System.Web.UI.WebControls.RequiredFieldValidator RFV_uid;
		protected System.Web.UI.WebControls.TextBox UserID;
		protected System.Web.UI.WebControls.RequiredFieldValidator RFV_ln;
		protected System.Web.UI.WebControls.TextBox LName;
		protected System.Web.UI.WebControls.RequiredFieldValidator RFV_add1;
		protected System.Web.UI.WebControls.TextBox AddressOne;
		protected System.Web.UI.WebControls.RequiredFieldValidator RFV_city;
		protected System.Web.UI.WebControls.TextBox City;
		protected System.Web.UI.WebControls.RequiredFieldValidator RFV_ZIP;
		protected System.Web.UI.WebControls.TextBox ZipCode;
		protected System.Web.UI.WebControls.RequiredFieldValidator RFV_pass;
		protected System.Web.UI.WebControls.TextBox Password;
		protected System.Web.UI.WebControls.RequiredFieldValidator RFV_cnfpass;
		protected System.Web.UI.WebControls.TextBox CnfPassword;
		protected System.Web.UI.WebControls.RequiredFieldValidator RFV_hans;
		protected System.Web.UI.WebControls.TextBox Hintans;
		protected System.Web.UI.WebControls.ValidationSummary valSum;
		protected System.Web.UI.WebControls.Button clear;
		protected System.Web.UI.WebControls.Button submit;
		protected System.Web.UI.WebControls.DropDownList Hintques;
		protected System.Web.UI.WebControls.RegularExpressionValidator RFV_MaFor;
		protected System.Web.UI.WebControls.RequiredFieldValidator RFV_mail;
		protected System.Web.UI.WebControls.TextBox Email;
		protected System.Web.UI.WebControls.DropDownList Country;
		protected System.Web.UI.WebControls.TextBox AddressThree;
		protected System.Web.UI.WebControls.TextBox AddressTwo;
		protected System.Web.UI.WebControls.DropDownList Year;
		protected System.Web.UI.WebControls.DropDownList Month;
		protected System.Web.UI.WebControls.DropDownList Day;
		protected System.Web.UI.WebControls.RadioButton Female;
		protected System.Web.UI.WebControls.RadioButton Male;
		protected System.Web.UI.WebControls.TextBox MName;
		protected bool ValidUser;
		protected System.Data.SqlClient.SqlConnection sqlcon;
		protected System.Data.SqlClient.SqlDataAdapter scmd;
		protected System.Data.SqlClient.SqlCommand scmdonly;
		protected System.Data.DataSet sqlDS;
		protected string Gender;
		protected System.Web.UI.WebControls.RequiredFieldValidator RFV1;
		protected System.Web.UI.HtmlControls.HtmlForm Form1;
		protected DateTime bday;

	
	public Registration()
	{
	    Page.Init += new System.EventHandler(Page_Init);
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                //
                // Evals true first time browser hits the page
                //
            }
        }

        protected void Page_Init(object sender, EventArgs e)
        {
            //
            // CODEGEN: This call is required by the ASP+ Windows Form Designer.
            //
            InitializeComponent();
        }

	public void ValidateAddForm()
	{

		ValidUser = true;
		CheckField (UserID.Text, "Please enter a valid user ID!");
		CheckField (FName.Text, "Please enter your First Name!");
		CheckField (LName.Text, "Please enter your Last Name!");
		CheckField (AddressOne.Text, "Please enter Your Address in the first column!");
		CheckField (City.Text, "Please enter the City of your address!");
		CheckField (ZipCode.Text, "Please enter a valid zip code");
		CheckField (Email.Text, "Please provide us with your email ID!");
		CheckFieldNumeric(ZipCode.Text, "The ZIP must be a number!");
		
		string uid = UserID.Text;
		if(Male.Checked==true)
		{
			Gender = "Male";
		}
		else
		{
			Gender = "Female";
		}
				
		int comp = compare(uid);
		
		if(AddressTwo.Text =="") //check to see if the Address column is filled!
		{
			AddressTwo.Text = null;
		}
		if(AddressThree.Text =="") //Check to see if the address field is filled!
		{
			AddressThree.Text = null;
		}
		if((ZipCode.Text.Length)<5) //Check to see if the is Valid.
		{
			Response.Write("<br><p><b>The Zip has to be a minimum of 5 characters.</b></p>");
			ValidUser=false;
			return;
		}
		
		if((Password.Text.Length)<5) //Check to see if the is Valid.
		{
			Response.Write("<br><p><b>The Password has to be a minimum of 5 characters.</b></p>");
			ValidUser=false;
			return;
		}

		if((CnfPassword.Text.Length)<5) //Check to see if the is Valid.
		{
			Response.Write("<br><p><b>The Confirm Password has to be a minimum of 5 characters.</b></p>");
			ValidUser=false;
			return;
		}

		if(Password.Text != CnfPassword.Text) //Check to see if the password and confirm password strings match.
		{
			Response.Write("<br><p><b>The Password and Confirm Password values do not match. Please re-enter them.</b></p>");
			ValidUser=false;
			return;
		}



		if((comp == 0 )&& (ValidUser == true))
		{
			Response.Write("<br><p><b>The User ID you have selected is already taken. Please select a different user ID. Thanx<b/></p>");
			return;
			//Request.UserID;//check this line of code for accuracy.
		}
		
		else if((ValidUser==true)&&(comp!=0))
		{
	
			add_user();

		}
		
		
	}

	private void DateVal()
	{
				string valid_date;
				valid_date=Day.SelectedItem.Text.ToString()+"/"+Month.SelectedItem.ToString()+"/"+Year.SelectedItem.ToString();
				try
				{
					bday = DateTime.Parse(valid_date);
				}
				catch(Exception ep)
				{
					ValidUser=false;					
					Response.Write("<br><b>The Date Selected by you is not valid. Please Select a different Date. Thanx</b>");
					return;
		
				}
			
				
	}
	
	public void CheckField (string strFieldValue, string strMsg)
	{
	  if(ValidUser==true)
	  { 
		if((strFieldValue.Length) == 0)
		{
			ValidUser = false;
			Response.Write("<p><b><br>"+strMsg+"</b></p>");
		}
	  }
	} 

	void CheckFieldNumeric (string strFieldValue, string strMsg)
	{
		if(ValidUser == true)
		{ 
			//Check to see if the field is invalid with non-numeric values
			int i = 10;
			if (i>0)
			{
			
				try
				{
					Decimal.Parse(strFieldValue);
				}
				catch(Exception ecp)
				{
					ValidUser = false;
					Response.Write(strMsg);
					return;
			
				}
			}
		
			 //It is numeric, make sure it is a positive number
				if(Decimal.Parse(strFieldValue) < 0 )
				{ 
					//Set project to not valid
					ValidUser = false;
					Response.Write( "All numeric values must be greater than or equal to zero!");
					return;
				}
			
		}
	}	//Check Field Numeric

	//function to compare the user ids before insertion to validate.
	int compare (string cus_id)
	{
		fillds();
		int i=1;
		string userid;
		foreach(DataRow dr in sqlDS.Tables[0].Rows )
		{
			userid=dr["Cust_ID"].ToString();
			if(cus_id.ToLower() == userid.ToLower())
			{
				Response.Write("The User ID you have selected is already taken. Please  select a different user ID. Thanx");
		
				return i=0;
	
			}
		}

	
		return i;
	}

	private void fillds()
	{
		//Check at the asp page level to verify that all the relevant boxes are duly 				//filled in with appropriate values.
		
		// The path mentioned here is assuming that the database is stored in a shared 				//path database on the books-client server.
		//string conn = @"server=books-client;uid=sa;pwd=; database = GreenStock";
		
		sqlcon = new SqlConnection (Global.server_path);
		
		if(sqlcon.State == ConnectionState.Open)
		{
			sqlcon.Close();
			
		}
		sqlcon.Open();
		scmd = new SqlDataAdapter ("Select * From Customer_tab", sqlcon);
		sqlDS = new DataSet();
		scmd.Fill(sqlDS,"Customer_tab");			
		
	}

	public void Submit_click(Object obj, EventArgs earg)
	{
		DateVal();
		if(Page.IsValid)
		{
			ValidateAddForm();

		}
		if(sqlcon.State == ConnectionState.Open)
		{
			sqlcon.Close();
		}
		

	}

	private void add_user()
	{
		fillds();
		//SqlTransaction try_1;
		if(sqlcon.State == ConnectionState.Open) 
		{
			sqlcon.Close();
		}
		sqlcon.Open();
		SqlTransaction sqt = sqlcon.BeginTransaction(IsolationLevel.ReadCommitted);
		
		try
		{
			string date;
			date = bday.ToShortDateString();
			
		
			string values = @"Insert Into Customer_tab Values ('"+ UserID.Text+"' , '"+ FName.Text+"', '"+MName.Text+"', '"+LName.Text+"', '"+date+"', '"+AddressOne.Text+"', '"+AddressTwo.Text+"', '"+AddressThree.Text+"', '"+City.Text+"', '"+Country.SelectedItem+"', '"+ZipCode.Text+"', '"+Email.Text+"')";
			//Please note that the names have to match the variable names used to 			//trap the validated values provided by the user.
		
			scmdonly = new SqlCommand(values,sqlcon);
			
			scmdonly.Transaction = sqt;
			scmdonly.ExecuteNonQuery();
			
			values = @"Insert Into Login_tab Values ( '"+ UserID.Text+"' , '"+ Password.Text+"', 'NULL','"+Hintques.SelectedItem.ToString()+"', '"+Hintans.Text+"')";
			scmdonly.CommandText = values;
			scmdonly.ExecuteNonQuery();
			sqt.Commit();
			
			
			//Response.Write("<br><p><b>Congrats! You have registered successfully as a member of Green Stock Systems.</b></p>");
			//Response.Write("<br><p><b>Welcome to Green Stock Systems, refer to the Deals section for our exclusive deals on software titles.</b></p>");
			Clear_click();
			Response.Redirect("Deals.aspx");

		}
		catch (Exception ecp)
		{
			Response.Write(ecp.ToString());
			Response.Write("<br><p><b>Sorry! We were unable to accept you as a member of Green Stock Sytems. Please try again later. We regret the inconvenience.</b></p>");
			sqt.Rollback();
					
		}
		finally
		{
			if(sqlcon.State==ConnectionState.Open)
			{
			sqlcon.Close();
			}
			
		}


	}

        /// <summary>
        ///    Required method for Designer support - do not modify
        ///    the contents of this method with the code editor.
        /// </summary>
	
	public void Clear_click(Object obj, EventArgs arg)
	{
		
		 
		UserID.Text="";
		FName.Text="";
		MName.Text="";
		LName.Text=""; 
		Day.SelectedIndex = 0;
		Month.SelectedIndex = 0;
		Year.SelectedIndex = 0;
		AddressOne.Text = "";
		AddressTwo.Text = "";
		AddressThree.Text = "";
		City.Text = "";
		Country.SelectedIndex = 0;
		ZipCode.Text = "";
		Email.Text ="";
		Password.Text = "";
		CnfPassword.Text = "";
		Hintques.SelectedIndex = 0;
		Hintans.Text = "";

	}			


	private void Clear_click()
	{
		UserID.Text="";
		FName.Text="";
		MName.Text="";
		LName.Text="";
		Day.SelectedIndex = 0;
		Month.SelectedIndex = 0;
		Year.SelectedIndex = 0;
		AddressOne.Text = "";
		AddressTwo.Text = "";
		AddressThree.Text = "";
		City.Text = "";
		Country.SelectedIndex = 0;
		ZipCode.Text = "";
		Email.Text ="";
		Password.Text = "";
		CnfPassword.Text = "";
		Hintques.SelectedIndex = 0;
		Hintans.Text = "";

	}			

        /// <summary>
        ///    Required method for Designer support - do not modify
        ///    the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
		{
			this.submit.Click += new System.EventHandler(this.Submit_click);
			this.clear.Click += new System.EventHandler(this.Clear_click);

		}

		
		public void submit_Click (object sender, System.EventArgs e)
		{
			DateVal();
			if(Page.IsValid)
			{
				ValidateAddForm();
			
			}
			if(sqlcon.State == ConnectionState.Open)
			{
				sqlcon.Close();
			}
			Response.Redirect("Deals.aspx");


		}
    }
}
